(use srfi-1 utils base64)

(define test-string (read-all (open-input-file "base64-in")))

(define encoded (base64:encode test-string))

(define known-result (read-all (open-input-file "base64-out")))

(if (string=? encoded known-result)
    (print "Success.")
    (for-each (let ((n 0))
                (lambda (pair)
                  (print n ": " pair " - " (if (char=? (car pair) (cadr pair)) "OK" "ERROR"))
                  (set! n (add1 n))))
              (zip (string->list encoded)
                   (string->list known-result))))

